// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from gps_msgs:msg/GPSFix.idl
// generated code does not contain a copyright notice
#include "gps_msgs/msg/gps_fix__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `status`
#include "gps_msgs/msg/gps_status__functions.h"

bool
gps_msgs__msg__GPSFix__init(gps_msgs__msg__GPSFix * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    gps_msgs__msg__GPSFix__fini(msg);
    return false;
  }
  // status
  if (!gps_msgs__msg__GPSStatus__init(&msg->status)) {
    gps_msgs__msg__GPSFix__fini(msg);
    return false;
  }
  // latitude
  // longitude
  // altitude
  // track
  // speed
  // climb
  // pitch
  // roll
  // dip
  // time
  // gdop
  // pdop
  // hdop
  // vdop
  // tdop
  // err
  // err_horz
  // err_vert
  // err_track
  // err_speed
  // err_climb
  // err_time
  // err_pitch
  // err_roll
  // err_dip
  // position_covariance
  // position_covariance_type
  return true;
}

void
gps_msgs__msg__GPSFix__fini(gps_msgs__msg__GPSFix * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // status
  gps_msgs__msg__GPSStatus__fini(&msg->status);
  // latitude
  // longitude
  // altitude
  // track
  // speed
  // climb
  // pitch
  // roll
  // dip
  // time
  // gdop
  // pdop
  // hdop
  // vdop
  // tdop
  // err
  // err_horz
  // err_vert
  // err_track
  // err_speed
  // err_climb
  // err_time
  // err_pitch
  // err_roll
  // err_dip
  // position_covariance
  // position_covariance_type
}

gps_msgs__msg__GPSFix *
gps_msgs__msg__GPSFix__create()
{
  gps_msgs__msg__GPSFix * msg = (gps_msgs__msg__GPSFix *)malloc(sizeof(gps_msgs__msg__GPSFix));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(gps_msgs__msg__GPSFix));
  bool success = gps_msgs__msg__GPSFix__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
gps_msgs__msg__GPSFix__destroy(gps_msgs__msg__GPSFix * msg)
{
  if (msg) {
    gps_msgs__msg__GPSFix__fini(msg);
  }
  free(msg);
}


bool
gps_msgs__msg__GPSFix__Sequence__init(gps_msgs__msg__GPSFix__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  gps_msgs__msg__GPSFix * data = NULL;
  if (size) {
    data = (gps_msgs__msg__GPSFix *)calloc(size, sizeof(gps_msgs__msg__GPSFix));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = gps_msgs__msg__GPSFix__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        gps_msgs__msg__GPSFix__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
gps_msgs__msg__GPSFix__Sequence__fini(gps_msgs__msg__GPSFix__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      gps_msgs__msg__GPSFix__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

gps_msgs__msg__GPSFix__Sequence *
gps_msgs__msg__GPSFix__Sequence__create(size_t size)
{
  gps_msgs__msg__GPSFix__Sequence * array = (gps_msgs__msg__GPSFix__Sequence *)malloc(sizeof(gps_msgs__msg__GPSFix__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = gps_msgs__msg__GPSFix__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
gps_msgs__msg__GPSFix__Sequence__destroy(gps_msgs__msg__GPSFix__Sequence * array)
{
  if (array) {
    gps_msgs__msg__GPSFix__Sequence__fini(array);
  }
  free(array);
}
