#ifndef H_1D197FCB4B675B4F6EEBE2DB15DFE219_GPSFix_SPLTYPES_H
#define H_1D197FCB4B675B4F6EEBE2DB15DFE219_GPSFix_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_GPSFix_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "gps_msgs/msg/dds_opensplice/GPSStatus_SplDcps.h"



extern c_metaObject __GPSFix__gps_msgs__load (c_base base);

extern c_metaObject __GPSFix__gps_msgs_msg__load (c_base base);

extern c_metaObject __GPSFix__gps_msgs_msg_dds___load (c_base base);

extern c_metaObject __GPSFix__gps_msgs_msg_dds__GPSFix_Constants__load (c_base base);

extern const char *gps_msgs_msg_dds__GPSFix__metaDescriptor[];
extern const int gps_msgs_msg_dds__GPSFix__metaDescriptorArrLength;
extern const int gps_msgs_msg_dds__GPSFix__metaDescriptorLength;
extern c_metaObject __gps_msgs_msg_dds__GPSFix___load (c_base base);
struct _gps_msgs_msg_dds__GPSFix_ ;
extern  v_copyin_result __gps_msgs_msg_dds__GPSFix___copyIn(c_base base, const struct gps_msgs::msg::dds_::GPSFix_ *from, struct _gps_msgs_msg_dds__GPSFix_ *to);
extern  void __gps_msgs_msg_dds__GPSFix___copyOut(const void *_from, void *_to);
struct _gps_msgs_msg_dds__GPSFix_ {
    struct _std_msgs_msg_dds__Header_ header_;
    struct _gps_msgs_msg_dds__GPSStatus_ status_;
    c_double latitude_;
    c_double longitude_;
    c_double altitude_;
    c_double track_;
    c_double speed_;
    c_double climb_;
    c_double pitch_;
    c_double roll_;
    c_double dip_;
    c_double time_;
    c_double gdop_;
    c_double pdop_;
    c_double hdop_;
    c_double vdop_;
    c_double tdop_;
    c_double err_;
    c_double err_horz_;
    c_double err_vert_;
    c_double err_track_;
    c_double err_speed_;
    c_double err_climb_;
    c_double err_time_;
    c_double err_pitch_;
    c_double err_roll_;
    c_double err_dip_;
    c_double position_covariance_[9];
    c_octet position_covariance_type_;
};

#undef OS_API
#endif
