// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from gps_msgs:msg/GPSStatus.idl
// generated code does not contain a copyright notice
#include "gps_msgs/msg/gps_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `satellite_used_prn`
// Member `satellite_visible_prn`
// Member `satellite_visible_z`
// Member `satellite_visible_azimuth`
// Member `satellite_visible_snr`
#include "rosidl_generator_c/primitives_sequence_functions.h"

bool
gps_msgs__msg__GPSStatus__init(gps_msgs__msg__GPSStatus * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    gps_msgs__msg__GPSStatus__fini(msg);
    return false;
  }
  // satellites_used
  // satellite_used_prn
  if (!rosidl_generator_c__int32__Sequence__init(&msg->satellite_used_prn, 0)) {
    gps_msgs__msg__GPSStatus__fini(msg);
    return false;
  }
  // satellites_visible
  // satellite_visible_prn
  if (!rosidl_generator_c__int32__Sequence__init(&msg->satellite_visible_prn, 0)) {
    gps_msgs__msg__GPSStatus__fini(msg);
    return false;
  }
  // satellite_visible_z
  if (!rosidl_generator_c__int32__Sequence__init(&msg->satellite_visible_z, 0)) {
    gps_msgs__msg__GPSStatus__fini(msg);
    return false;
  }
  // satellite_visible_azimuth
  if (!rosidl_generator_c__int32__Sequence__init(&msg->satellite_visible_azimuth, 0)) {
    gps_msgs__msg__GPSStatus__fini(msg);
    return false;
  }
  // satellite_visible_snr
  if (!rosidl_generator_c__int32__Sequence__init(&msg->satellite_visible_snr, 0)) {
    gps_msgs__msg__GPSStatus__fini(msg);
    return false;
  }
  // status
  // motion_source
  // orientation_source
  // position_source
  return true;
}

void
gps_msgs__msg__GPSStatus__fini(gps_msgs__msg__GPSStatus * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // satellites_used
  // satellite_used_prn
  rosidl_generator_c__int32__Sequence__fini(&msg->satellite_used_prn);
  // satellites_visible
  // satellite_visible_prn
  rosidl_generator_c__int32__Sequence__fini(&msg->satellite_visible_prn);
  // satellite_visible_z
  rosidl_generator_c__int32__Sequence__fini(&msg->satellite_visible_z);
  // satellite_visible_azimuth
  rosidl_generator_c__int32__Sequence__fini(&msg->satellite_visible_azimuth);
  // satellite_visible_snr
  rosidl_generator_c__int32__Sequence__fini(&msg->satellite_visible_snr);
  // status
  // motion_source
  // orientation_source
  // position_source
}

gps_msgs__msg__GPSStatus *
gps_msgs__msg__GPSStatus__create()
{
  gps_msgs__msg__GPSStatus * msg = (gps_msgs__msg__GPSStatus *)malloc(sizeof(gps_msgs__msg__GPSStatus));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(gps_msgs__msg__GPSStatus));
  bool success = gps_msgs__msg__GPSStatus__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
gps_msgs__msg__GPSStatus__destroy(gps_msgs__msg__GPSStatus * msg)
{
  if (msg) {
    gps_msgs__msg__GPSStatus__fini(msg);
  }
  free(msg);
}


bool
gps_msgs__msg__GPSStatus__Sequence__init(gps_msgs__msg__GPSStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  gps_msgs__msg__GPSStatus * data = NULL;
  if (size) {
    data = (gps_msgs__msg__GPSStatus *)calloc(size, sizeof(gps_msgs__msg__GPSStatus));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = gps_msgs__msg__GPSStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        gps_msgs__msg__GPSStatus__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
gps_msgs__msg__GPSStatus__Sequence__fini(gps_msgs__msg__GPSStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      gps_msgs__msg__GPSStatus__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

gps_msgs__msg__GPSStatus__Sequence *
gps_msgs__msg__GPSStatus__Sequence__create(size_t size)
{
  gps_msgs__msg__GPSStatus__Sequence * array = (gps_msgs__msg__GPSStatus__Sequence *)malloc(sizeof(gps_msgs__msg__GPSStatus__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = gps_msgs__msg__GPSStatus__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
gps_msgs__msg__GPSStatus__Sequence__destroy(gps_msgs__msg__GPSStatus__Sequence * array)
{
  if (array) {
    gps_msgs__msg__GPSStatus__Sequence__fini(array);
  }
  free(array);
}
